Hex Artifact Content

Artifact dcf6e62dd76b0c4641da04005b1bd97455dae5a4:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 70 6b 67 3d 22 24 28 65 63 68  bash..pkg="$(ech
0020: 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73 40  o "$1" | sed 's@
0030: 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40 40  /*$@@;s@^\.*/*@@
0040: 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  ')"..if [ -z "${
0050: 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65  pkg}" ]; then..e
0060: 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69 6c  cho "Usage: buil
0070: 64 20 3c 70 61 63 6b 61 67 65 3e 22 20 32 3e 26  d <package>" 2>&
0080: 31 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 66  1...exit 1.fi..f
0090: 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e  unction determin
00a0: 65 4f 73 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d  eOsArch() {..os=
00b0: 22 24 28 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64  "$(uname -s | dd
00c0: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
00d0: 65 76 2f 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d  ev/null)"..arch=
00e0: 22 24 28 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64  "$(uname -m | dd
00f0: 20 63 6f 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64   conv=lcase 2>/d
0100: 65 76 2f 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65  ev/null)"...case
0110: 20 22 24 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09   "${arch}" in...
0120: 69 3f 38 36 29 0a 09 09 09 61 72 63 68 3d 27 69  i?86)....arch='i
0130: 78 38 36 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63  x86'....;;..esac
0140: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74  .}..function det
0150: 65 72 6d 69 6e 65 50 72 65 66 69 78 28 29 20 7b  erminePrefix() {
0160: 0a 09 64 65 74 65 72 6d 69 6e 65 4f 73 41 72 63  ..determineOsArc
0170: 68 0a 0a 09 70 72 65 66 69 78 73 75 66 66 69 78  h...prefixsuffix
0180: 3d 22 24 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24  ="${pkg}/${os}-$
0190: 7b 61 72 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e  {arch}/${version
01a0: 7d 22 0a 09 70 72 65 66 69 78 3d 22 2f 6f 70 74  }"..prefix="/opt
01b0: 2f 61 70 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d  /appfs/${domain}
01c0: 2f 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  /${prefixsuffix}
01d0: 22 0a 09 64 65 73 74 64 69 72 3d 22 24 28 70 77  "..destdir="$(pw
01e0: 64 29 2f 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72  d)/INST"...mkdir
01f0: 20 22 24 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c   "${destdir}" ||
0200: 20 64 69 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e   die.}..function
0210: 20 70 72 65 63 6f 6e 66 69 67 75 72 65 28 29 20   preconfigure() 
0220: 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  {..:.}..function
0230: 20 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 28 29   postconfigure()
0240: 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f   {..:.}..functio
0250: 6e 20 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  n configure() {.
0260: 09 67 6c 69 62 63 76 65 72 73 3d 32 2e 32 30 0a  .glibcvers=2.20.
0270: 09 67 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f  .glibcdir="/opt/
0280: 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73  appfs/core.appfs
0290: 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62  .rkeene.org/glib
02a0: 63 2f 70 6c 61 74 66 6f 72 6d 2f 24 7b 67 6c 69  c/platform/${gli
02b0: 62 63 76 65 72 73 7d 22 0a 09 64 79 6e 6c 69 6e  bcvers}"..dynlin
02c0: 6b 65 72 3d 22 24 28 6c 73 20 22 24 7b 67 6c 69  ker="$(ls "${gli
02d0: 62 63 64 69 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c  bcdir}"/lib/ld-l
02e0: 69 6e 75 78 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69  inux*.so.* | tai
02f0: 6c 20 2d 6e 20 31 29 22 0a 0a 09 43 46 4c 41 47  l -n 1)"...CFLAG
0300: 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69 72 7d  S="-I${glibcdir}
0310: 2f 69 6e 63 6c 75 64 65 22 0a 09 43 50 50 46 4c  /include"..CPPFL
0320: 41 47 53 3d 22 2d 49 24 7b 67 6c 69 62 63 64 69  AGS="-I${glibcdi
0330: 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 09 4c 44 46  r}/include"..LDF
0340: 4c 41 47 53 3d 22 2d 57 6c 2c 2d 2d 72 70 61 74  LAGS="-Wl,--rpat
0350: 68 2c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69  h,${glibcdir}/li
0360: 62 20 2d 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d  b -Wl,--dynamic-
0370: 6c 69 6e 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b  linker,${dynlink
0380: 65 72 7d 22 0a 09 65 78 70 6f 72 74 20 43 46 4c  er}"..export CFL
0390: 41 47 53 20 43 50 50 46 4c 41 47 53 20 4c 44 46  AGS CPPFLAGS LDF
03a0: 4c 41 47 53 0a 0a 09 2e 2f 63 6f 6e 66 69 67 75  LAGS..../configu
03b0: 72 65 20 2d 2d 70 72 65 66 69 78 3d 22 24 7b 70  re --prefix="${p
03c0: 72 65 66 69 78 7d 22 20 2d 2d 73 79 73 63 6f 6e  refix}" --syscon
03d0: 66 64 69 72 3d 2f 65 74 63 20 2d 2d 6c 6f 63 61  fdir=/etc --loca
03e0: 6c 73 74 61 74 65 64 69 72 3d 2f 76 61 72 0a 7d  lstatedir=/var.}
03f0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 62 75  ..function prebu
0400: 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  ild() {..:.}..fu
0410: 6e 63 74 69 6f 6e 20 70 6f 73 74 62 75 69 6c 64  nction postbuild
0420: 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63 74  () {..:.}..funct
0430: 69 6f 6e 20 62 75 69 6c 64 28 29 20 7b 0a 09 67  ion build() {..g
0440: 72 65 70 20 22 44 45 53 54 44 49 52 22 20 4d 61  rep "DESTDIR" Ma
0450: 6b 65 66 69 6c 65 20 7c 7c 20 64 69 65 20 22 44  kefile || die "D
0460: 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20 74 6f  on't know how to
0470: 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f 66 74   build this soft
0480: 77 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a 0a  ware"...make.}..
0490: 66 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e 73 74  function preinst
04a0: 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  all() {..:.}..fu
04b0: 6e 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73 74 61  nction postinsta
04c0: 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e  ll() {..:.}..fun
04d0: 63 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28 29 20  ction install() 
04e0: 7b 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c 6c 20  {..make install 
04f0: 44 45 53 54 44 49 52 3d 22 24 7b 64 65 73 74 64  DESTDIR="${destd
0500: 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  ir}".}..function
0510: 20 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09 63 64   cleanup() {..cd
0520: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c   "${workdir}" ||
0530: 20 65 78 69 74 20 31 0a 09 63 64 20 2e 2e 20 7c   exit 1..cd .. |
0540: 7c 20 65 78 69 74 20 31 0a 09 72 6d 20 2d 72 66  | exit 1..rm -rf
0550: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d 0a   "${workdir}".}.
0560: 0a 66 75 6e 63 74 69 6f 6e 20 64 69 65 28 29 20  .function die() 
0570: 7b 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61 67 65  {..local message
0580: 0a 0a 09 6d 65 73 73 61 67 65 3d 22 24 31 22 0a  ...message="$1".
0590: 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d 65 73  ..if [ -n "${mes
05a0: 73 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  sage}" ]; then..
05b0: 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 24 7b  .echo "error: ${
05c0: 6d 65 73 73 61 67 65 7d 22 20 3e 26 32 0a 09 66  message}" >&2..f
05d0: 69 0a 0a 09 63 6c 65 61 6e 75 70 0a 0a 09 65 78  i...cleanup...ex
05e0: 69 74 20 31 0a 7d 0a 0a 63 64 20 22 24 28 64 69  it 1.}..cd "$(di
05f0: 72 6e 61 6d 65 20 22 24 28 77 68 69 63 68 20 22  rname "$(which "
0600: 24 30 22 29 22 29 22 20 7c 7c 20 65 78 69 74 20  $0")")" || exit 
0610: 31 0a 0a 69 66 20 5b 20 2d 66 20 27 62 75 69 6c  1..if [ -f 'buil
0620: 64 2e 63 6f 6e 66 27 20 5d 3b 20 74 68 65 6e 0a  d.conf' ]; then.
0630: 09 2e 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27 0a  .. 'build.conf'.
0640: 66 69 0a 0a 69 66 20 5b 20 2d 64 20 22 70 6b 67  fi..if [ -d "pkg
0650: 73 2f 24 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65  s/${pkg}" ]; the
0660: 6e 0a 09 70 6b 67 64 69 72 3d 22 70 6b 67 73 2f  n..pkgdir="pkgs/
0670: 24 7b 70 6b 67 7d 22 0a 09 70 6b 67 66 69 6c 65  ${pkg}"..pkgfile
0680: 3d 22 24 7b 70 6b 67 64 69 72 7d 2f 69 6e 66 6f  ="${pkgdir}/info
0690: 22 0a 65 6c 73 65 0a 09 70 6b 67 66 69 6c 65 3d  ".else..pkgfile=
06a0: 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22 0a 09 70  "pkgs/${pkg}"..p
06b0: 6b 67 64 69 72 3d 22 24 7b 70 6b 67 66 69 6c 65  kgdir="${pkgfile
06c0: 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 21 20 2d 65  }".fi..if [ ! -e
06d0: 20 22 24 7b 70 6b 67 66 69 6c 65 7d 22 20 5d 3b   "${pkgfile}" ];
06e0: 20 74 68 65 6e 0a 09 65 63 68 6f 20 22 49 6e 76   then..echo "Inv
06f0: 61 6c 69 64 20 70 61 63 6b 61 67 65 2e 22 20 3e  alid package." >
0700: 26 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a  &2...exit 1.fi..
0710: 70 6b 67 64 61 74 65 3d 22 24 28 66 6f 72 20 61  pkgdate="$(for a
0720: 72 74 69 66 61 63 74 20 69 6e 20 24 28 66 69 6e  rtifact in $(fin
0730: 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20 2d 74  d "${pkgdir}" -t
0740: 79 70 65 20 66 20 2d 70 72 69 6e 74 30 20 7c 20  ype f -print0 | 
0750: 78 61 72 67 73 20 2d 6e 20 31 20 2d 30 20 66 6f  xargs -n 1 -0 fo
0760: 73 73 69 6c 20 66 69 6e 66 6f 20 2d 2d 6c 69 6d  ssil finfo --lim
0770: 69 74 20 31 20 2d 2d 77 69 64 74 68 20 30 20 32  it 1 --width 0 2
0780: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 67 72 65  >/dev/null | gre
0790: 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30  p '^[0-9][0-9][0
07a0: 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d 39 5d 5b 30  -9][0-9]-[0-9][0
07b0: 2d 39 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 20 27  -9]-[0-9][0-9] '
07c0: 20 7c 20 73 65 64 20 27 73 40 5e 5b 5e 20 5d 2a   | sed 's@^[^ ]*
07d0: 20 5c 5b 40 40 3b 73 40 5c 5d 2e 2a 40 40 27 20   \[@@;s@\].*@@' 
07e0: 7c 20 73 6f 72 74 20 2d 75 29 3b 20 64 6f 20 66  | sort -u); do f
07f0: 6f 73 73 69 6c 20 69 6e 66 6f 20 22 24 7b 61 72  ossil info "${ar
0800: 74 69 66 61 63 74 7d 22 20 7c 20 61 77 6b 20 27  tifact}" | awk '
0810: 2f 5e 75 75 69 64 3a 2f 7b 20 70 72 69 6e 74 20  /^uuid:/{ print 
0820: 24 33 20 22 54 22 20 24 34 20 7d 27 20 7c 20 73  $3 "T" $4 }' | s
0830: 65 64 20 27 73 40 5b 2d 3a 5d 40 40 67 3b 73 40  ed 's@[-:]@@g;s@
0840: 2e 2e 24 40 5c 2e 26 40 27 3b 20 64 6f 6e 65 20  ..$@\.&@'; done 
0850: 7c 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c  | sort -n | tail
0860: 20 2d 6e 20 31 29 22 0a 69 66 20 5b 20 2d 7a 20   -n 1)".if [ -z 
0870: 22 24 7b 70 6b 67 64 61 74 65 7d 22 20 5d 3b 20  "${pkgdate}" ]; 
0880: 74 68 65 6e 0a 09 70 6b 67 64 61 74 65 3d 22 24  then..pkgdate="$
0890: 28 66 69 6e 64 20 22 24 7b 70 6b 67 64 69 72 7d  (find "${pkgdir}
08a0: 22 20 2d 74 79 70 65 20 66 20 2d 70 72 69 6e 74  " -type f -print
08b0: 66 20 27 25 54 59 25 54 6d 25 54 64 25 54 48 25  f '%TY%Tm%Td%TH%
08c0: 54 4d 2e 25 54 53 5c 6e 27 20 32 3e 2f 64 65 76  TM.%TS\n' 2>/dev
08d0: 2f 6e 75 6c 6c 20 7c 20 63 75 74 20 2d 66 20 31  /null | cut -f 1
08e0: 2d 32 20 2d 64 20 27 2e 27 20 7c 20 73 6f 72 74  -2 -d '.' | sort
08f0: 20 2d 6e 20 7c 20 74 61 69 6c 20 2d 6e 20 31 29   -n | tail -n 1)
0900: 22 0a 66 69 0a 0a 2e 20 22 24 7b 70 6b 67 66 69  ".fi... "${pkgfi
0910: 6c 65 7d 22 0a 0a 61 72 63 68 69 76 65 64 69 72  le}"..archivedir
0920: 3d 22 24 28 70 77 64 29 2f 41 52 43 48 49 56 45  ="$(pwd)/ARCHIVE
0930: 22 0a 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64  ".workdir="workd
0940: 69 72 2d 24 24 24 7b 52 41 4e 44 4f 4d 7d 24 7b  ir-$$${RANDOM}${
0950: 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d  RANDOM}${RANDOM}
0960: 22 0a 73 72 63 66 69 6c 65 3d 22 24 7b 61 72 63  ".srcfile="${arc
0970: 68 69 76 65 64 69 72 7d 2f 24 7b 70 6b 67 7d 22  hivedir}/${pkg}"
0980: 0a 6d 6b 64 69 72 20 22 24 7b 61 72 63 68 69 76  .mkdir "${archiv
0990: 65 64 69 72 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c  edir}" >/dev/nul
09a0: 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 6d 6b  l 2>/dev/null.mk
09b0: 64 69 72 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  dir "${workdir}"
09c0: 20 7c 7c 20 65 78 69 74 20 31 0a 63 64 20 22 24   || exit 1.cd "$
09d0: 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78  {workdir}" || ex
09e0: 69 74 20 31 0a 77 6f 72 6b 64 69 72 3d 22 24 28  it 1.workdir="$(
09f0: 70 77 64 29 22 0a 0a 69 66 20 5b 20 21 20 2d 65  pwd)"..if [ ! -e
0a00: 20 22 24 7b 73 72 63 66 69 6c 65 7d 22 20 5d 3b   "${srcfile}" ];
0a10: 20 74 68 65 6e 0a 09 23 20 44 6f 77 6e 6c 6f 61   then..# Downloa
0a20: 64 0a 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 72  d..## Cleanup..r
0a30: 6d 20 2d 66 20 73 72 63 2e 6e 65 77 20 73 72 63  m -f src.new src
0a40: 0a 0a 09 23 23 20 46 65 74 63 68 20 66 69 6c 65  ...## Fetch file
0a50: 0a 09 77 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65  ..wget -O src.ne
0a60: 77 20 22 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78  w "${url}" || ex
0a70: 69 74 20 31 0a 0a 09 23 23 20 56 65 72 69 66 79  it 1...## Verify
0a80: 20 73 69 67 6e 61 74 75 72 65 0a 09 73 72 63 5f   signature..src_
0a90: 73 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73  sha256="$(openss
0aa0: 6c 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65  l sha256 'src.ne
0ab0: 77 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d  w' | sed 's@^.*=
0ac0: 20 40 40 27 29 22 0a 09 69 66 20 5b 20 22 24 7b   @@')"..if [ "${
0ad0: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0ae0: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0af0: 68 65 6e 0a 09 09 65 63 68 6f 20 22 53 48 41 32  hen...echo "SHA2
0b00: 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44 6f  56 mismatch:  Do
0b10: 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63 5f  wnloaded: ${src_
0b20: 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65 63  sha256} != Expec
0b30: 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22 20  ted: ${sha256}" 
0b40: 3e 26 32 0a 0a 09 09 65 78 69 74 20 31 0a 09 66  >&2....exit 1..f
0b50: 69 0a 0a 09 23 23 20 4d 6f 76 65 20 66 69 6c 65  i...## Move file
0b60: 20 69 6e 74 6f 20 70 6c 61 63 65 0a 09 6d 76 20   into place..mv 
0b70: 73 72 63 2e 6e 65 77 20 22 24 7b 61 72 63 68 69  src.new "${archi
0b80: 76 65 64 69 72 7d 2f 24 7b 70 6b 67 7d 22 0a 66  vedir}/${pkg}".f
0b90: 69 0a 0a 23 20 44 65 63 6f 6d 70 72 65 73 73 20  i..# Decompress 
0ba0: 61 72 63 68 69 76 65 0a 23 23 20 44 65 74 65 72  archive.## Deter
0bb0: 6d 69 6e 65 20 74 79 70 65 20 6f 66 20 61 72 63  mine type of arc
0bc0: 68 69 76 65 0a 63 61 73 65 20 22 24 7b 75 72 6c  hive.case "${url
0bd0: 7d 22 20 69 6e 0a 09 2a 2e 74 61 72 2e 78 7a 7c  }" in..*.tar.xz|
0be0: 2a 2e 74 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74  *.tar.xz'?'*|*.t
0bf0: 78 7a 29 0a 09 09 64 65 63 6f 6d 70 72 65 73 73  xz)...decompress
0c00: 3d 27 78 7a 27 0a 09 09 3b 3b 0a 09 2a 2e 74 61  ='xz'...;;..*.ta
0c10: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0c20: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 64 65 63 6f 6d  *|*.tgz)...decom
0c30: 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09 3b  press='gzip'...;
0c40: 3b 0a 09 2a 2e 74 61 72 2e 62 7a 32 7c 2a 2e 74  ;..*.tar.bz2|*.t
0c50: 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e 74 62 7a  ar.bz2'?'*|*.tbz
0c60: 32 29 0a 09 09 64 65 63 6f 6d 70 72 65 73 73 3d  2)...decompress=
0c70: 27 62 7a 69 70 32 27 0a 09 09 3b 3b 0a 09 2a 2e  'bzip2'...;;..*.
0c80: 7a 69 70 7c 2a 2e 7a 69 70 27 3f 27 2a 29 0a 09  zip|*.zip'?'*)..
0c90: 09 64 65 63 6f 6d 70 72 65 73 73 3d 27 75 6e 7a  .decompress='unz
0ca0: 69 70 27 0a 09 09 3b 3b 0a 09 2a 29 0a 09 09 65  ip'...;;..*)...e
0cb0: 63 68 6f 20 22 55 6e 6b 6e 6f 77 6e 20 63 6f 6d  cho "Unknown com
0cc0: 70 72 65 73 73 69 6f 6e 20 6d 65 74 68 6f 64 3a  pression method:
0cd0: 20 24 7b 75 72 6c 7d 22 20 3e 26 32 0a 0a 09 09   ${url}" >&2....
0ce0: 65 78 69 74 20 31 0a 09 09 3b 3b 0a 65 73 61 63  exit 1...;;.esac
0cf0: 0a 0a 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65  ..## Do decompre
0d00: 73 73 69 6f 6e 0a 63 61 73 65 20 22 24 7b 64 65  ssion.case "${de
0d10: 63 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 75  compress}" in..u
0d20: 6e 7a 69 70 29 0a 09 09 75 6e 7a 69 70 20 22 24  nzip)...unzip "$
0d30: 7b 73 72 63 66 69 6c 65 7d 22 20 7c 7c 20 64 69  {srcfile}" || di
0d40: 65 20 27 55 6e 61 62 6c 65 20 74 6f 20 75 6e 63  e 'Unable to unc
0d50: 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76 65 27  ompress archive'
0d60: 0a 09 09 3b 3b 0a 09 2a 29 0a 09 09 22 24 7b 64  ...;;..*)..."${d
0d70: 65 63 6f 6d 70 72 65 73 73 7d 22 20 2d 64 63 20  ecompress}" -dc 
0d80: 22 24 7b 73 72 63 66 69 6c 65 7d 22 20 7c 20 74  "${srcfile}" | t
0d90: 61 72 20 2d 78 66 20 2d 20 7c 7c 20 64 69 65 20  ar -xf - || die 
0da0: 27 55 6e 61 62 6c 65 20 74 6f 20 75 6e 63 6f 6d  'Unable to uncom
0db0: 70 72 65 73 73 20 61 72 63 68 69 76 65 27 0a 09  press archive'..
0dc0: 09 3b 3b 0a 65 73 61 63 0a 0a 23 23 20 43 6c 65  .;;.esac..## Cle
0dd0: 61 6e 75 70 20 73 6f 75 72 63 65 0a 72 6d 20 2d  anup source.rm -
0de0: 66 20 73 72 63 0a 0a 23 20 49 66 20 77 65 20 6a  f src..# If we j
0df0: 75 73 74 20 68 61 76 65 20 6f 6e 65 20 64 69 72  ust have one dir
0e00: 65 63 74 6f 72 79 2c 20 75 73 65 20 74 68 61 74  ectory, use that
0e10: 20 64 69 72 65 63 74 6f 72 79 0a 64 69 72 3d 22   directory.dir="
0e20: 24 28 65 63 68 6f 20 2a 29 22 0a 69 66 20 5b 20  $(echo *)".if [ 
0e30: 2d 65 20 22 24 7b 64 69 72 7d 22 20 5d 3b 20 74  -e "${dir}" ]; t
0e40: 68 65 6e 0a 09 6d 76 20 22 24 7b 64 69 72 7d 22  hen..mv "${dir}"
0e50: 2f 2a 20 2e 0a 66 69 0a 0a 23 20 53 74 61 72 74  /* ..fi..# Start
0e60: 20 6c 6f 67 67 69 6e 67 0a 73 65 74 20 2d 78 0a   logging.set -x.
0e70: 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 70 72 6f  .# Determine pro
0e80: 70 65 72 74 69 65 73 0a 64 65 74 65 72 6d 69 6e  perties.determin
0e90: 65 50 72 65 66 69 78 0a 0a 23 20 53 74 61 72 74  ePrefix..# Start
0ea0: 20 74 68 65 20 62 75 69 6c 64 0a 70 72 65 63 6f   the build.preco
0eb0: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
0ec0: 70 72 65 63 6f 6e 66 69 67 75 72 65 20 66 61 69  preconfigure fai
0ed0: 6c 65 64 27 0a 63 6f 6e 66 69 67 75 72 65 20 7c  led'.configure |
0ee0: 7c 20 64 69 65 20 27 63 6f 6e 66 69 67 75 72 65  | die 'configure
0ef0: 20 66 61 69 6c 65 64 27 0a 70 6f 73 74 63 6f 6e   failed'.postcon
0f00: 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27 70  figure || die 'p
0f10: 6f 73 74 63 6f 6e 66 69 67 75 72 65 20 66 61 69  ostconfigure fai
0f20: 6c 65 64 27 0a 0a 70 72 65 62 75 69 6c 64 20 7c  led'..prebuild |
0f30: 7c 20 64 69 65 20 27 70 72 65 62 75 69 6c 64 20  | die 'prebuild 
0f40: 66 61 69 6c 65 64 27 0a 62 75 69 6c 64 20 7c 7c  failed'.build ||
0f50: 20 64 69 65 20 27 62 75 69 6c 64 20 66 61 69 6c   die 'build fail
0f60: 65 64 27 0a 70 6f 73 74 62 75 69 6c 64 20 7c 7c  ed'.postbuild ||
0f70: 20 64 69 65 20 27 70 6f 73 74 62 75 69 6c 64 20   die 'postbuild 
0f80: 66 61 69 6c 65 64 27 0a 0a 70 72 65 69 6e 73 74  failed'..preinst
0f90: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 72 65 69  all || die 'prei
0fa0: 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 69  nstall failed'.i
0fb0: 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27 69  nstall || die 'i
0fc0: 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 70  nstall failed'.p
0fd0: 6f 73 74 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69  ostinstall || di
0fe0: 65 20 27 70 6f 73 74 69 6e 73 74 61 6c 6c 20 66  e 'postinstall f
0ff0: 61 69 6c 65 64 27 0a 0a 28 0a 09 61 70 70 64 69  ailed'..(..appdi
1000: 72 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c  r="$(appfsinstal
1010: 6c 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75  ldir)/${prefixsu
1020: 66 66 69 78 7d 22 0a 09 6d 6b 64 69 72 20 2d 70  ffix}"..mkdir -p
1030: 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09 63   "${appdir}"...c
1040: 64 20 22 24 7b 64 65 73 74 64 69 72 7d 2f 24 7b  d "${destdir}/${
1050: 70 72 65 66 69 78 7d 22 20 7c 7c 20 65 78 69 74  prefix}" || exit
1060: 20 31 0a 09 63 70 20 2d 72 70 20 2a 20 22 24 7b   1..cp -rp * "${
1070: 61 70 70 64 69 72 7d 22 0a 09 66 69 6e 64 20 22  appdir}"..find "
1080: 24 7b 61 70 70 64 69 72 7d 22 20 2d 70 72 69 6e  ${appdir}" -prin
1090: 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f  t0 | xargs -0 to
10a0: 75 63 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74  uch -t "${pkgdat
10b0: 65 7d 22 0a 29 0a 0a 63 6c 65 61 6e 75 70 0a 0a  e}".)..cleanup..
10c0: 65 78 69 74 20 30 0a                             exit 0.